<template>
  <q-page padding>
    <div class="col justify-center items-center">
      <div class="row justify-center items-center" style="text-align: center">
        <h4>Todos los Gamers</h4>
      </div>

      <div class="row justify-center items-center">
        <q-list bordered separator style="width: 85%">
          <q-item v-for=" user in users " v-bind:key="user.username" clickable v-ripple>
            <q-item-section avatar>
              <q-avatar color="primary" text-color="white">{{user.username.charAt(0).toUpperCase()}}</q-avatar>
            </q-item-section>

            <q-item-section>
              <q-item-label>{{user.username}}</q-item-label>
              <q-item-label caption lines="1">{{ user.email }}</q-item-label>
            </q-item-section>

            <q-item-section side>
              <div class="row">
                <q-btn
                  @click="edit = true; userToUpdate=user"
                  color="secondary"
                  size="12px"
                  flat
                  dense
                  round
                  icon="edit"
                />
                <q-btn
                  @click="borrarUser = true; userToDelete = user.id"
                  color="red"
                  size="12px"
                  flat
                  dense
                  round
                  icon="delete"
                />
              </div>
            </q-item-section>
          </q-item>
        </q-list>

        <q-btn @click="add= true" class="plus" fab icon="add" color="accent" />

        <q-dialog v-model="borrarUser">
          <q-card>
            <q-card-section class="row items-center">
              <q-avatar icon="delete" color="primary" text-color="white" />
              <span class="q-ml-sm">¿Está seguro que desea eliminar este usuario?</span>
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat label="No" color="primary" v-close-popup />
              <q-btn @click="borrar" flat label="Si, mándale mecha" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>

        <q-dialog v-model="edit">
          <q-card style="min-width: 350px">
            <q-card-section>
              <div class="text-h6">Editar usuario</div>
            </q-card-section>

            <q-card-section>
              <q-input
                rounded
                outlined
                type="email"
                v-model="email"
                label="Correo electronico"
                lazy-rules
                :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
              >
                <template v-slot:prepend>
                  <q-icon name="email" />
                </template>
              </q-input>

              <q-input
                rounded
                outlined
                v-model="username"
                label="Usuario"
                lazy-rules
                :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
              >
                <template v-slot:prepend>
                  <q-icon name="person" />
                </template>
              </q-input>

              <q-input
                rounded
                outlined
                type="password"
                v-model="password"
                label="Contraseña"
                lazy-rules
                :rules="[
          val => val !== null && val !== '' || 'Ingrese una contraseña'
        ]"
              >
                <template v-slot:prepend>
                  <q-icon name="lock" />
                </template>
              </q-input>
            </q-card-section>

            <q-card-actions align="right" class="text-primary">
              <q-btn flat label="Cerrar" v-close-popup />
              <q-btn @click="editar" flat label="Editar" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>
        <q-dialog v-model="add">
          <q-card style="min-width: 350px">
            <q-card-section>
              <div class="text-h6">Agregar usuario</div>
            </q-card-section>

            <q-card-section>
              <q-input
                rounded
                outlined
                type="email"
                v-model="email"
                label="Correo electronico"
                lazy-rules
                :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
              >
                <template v-slot:prepend>
                  <q-icon name="email" />
                </template>
              </q-input>

              <q-input
                rounded
                outlined
                v-model="username"
                label="Usuario"
                lazy-rules
                :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
              >
                <template v-slot:prepend>
                  <q-icon name="person" />
                </template>
              </q-input>

              <q-input
                rounded
                outlined
                type="password"
                v-model="password"
                label="Contraseña"
                lazy-rules
                :rules="[
          val => val !== null && val !== '' || 'Ingrese una contraseña'
        ]"
              >
                <template v-slot:prepend>
                  <q-icon name="lock" />
                </template>
              </q-input>
            </q-card-section>

            <q-card-actions align="right" class="text-primary">
              <q-btn flat label="Cerrar" v-close-popup />
              <q-btn @click="addUser" flat label="Agregar" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>
      </div>
    </div>
  </q-page>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      users: [],
      borrarUser: false,
      edit: false,
      add: false,
      username: "",
      password: "",
      email: "",
      userToDelete: null,
      userToUpdate: null
    };
  },
  methods: {
    addUser() {
      axios
        .post("http://10.0.2.2:5000/api/user/", {
          username: this.username,
          password: this.password,
          email: this.email
        })
        .then(response => {
          this.$q.notify("Cuenta creada con exito");
          this.reloadUser();
        });
    },
    reloadUser() {
      this.username="";
      this.email="";
      this.password="";
      this.userToDelete= null;
      this.userToUpdate=null;
      

      axios
        .get("http://10.0.2.2:5000/api/user/")
        .then(
          response =>
            (this.users = response.data.filter(
              user => user.username !== this.$store.state.loggedUser
            ))
        );
    },
    borrar() {
      axios
        .delete("http://10.0.2.2:5000/api/user/" + this.userToDelete)
        .then(response => {
          this.$q.notify("Cuenta eliminada con exito");
          this.reloadUser();
        });
    },
    editar() {
      axios
        .put(
          "http://10.0.2.2:5000/api/user/" + this.userToUpdate.id,{
            username: this.username,
          password: this.password,
          email:this.email
          }
          
        )
        .then(response => {
          this.$q.notify("Cuenta editada con exito");
          this.reloadUser();
        });
    }
  },

  mounted() {
    this.reloadUser();
  }
};
</script>

<style scoped>
.plus {
  position: fixed;
  bottom: 30px;
  right: 32px;
}
</style>